#ifdef __GNUC__
#pragma interface
#endif
#ifndef __Curses_h
#define __Curses_h
#include "window.hpp"

class CursesWin: virtual public Window {
  CursesWin(const CursesWin &);
  CursesWin &operator=(const CursesWin &);
  bool scrollflag;
protected:
  struct rowdata {
    short modc;
    short data;
  };
  short wrow, wcol;	/* position of window in virtual screen */
  CHTYPE far *data;	/* virtual screen */
  void size(int,int);
  rowdata *d;
protected:
  short crow, ccol;	/* cursor position in virtual screen */
public:
  CHTYPE attr;		/* current attributes */
  short rows, cols;	/* size of virtual screen */
  CursesWin(int rows, int cols);
  ~CursesWin();
  void draw(const Rect &);
  //void setphys(const Rect &);
  void curpos(int row,int col);
  void sync();
  void addch(char);	// add char, interpret whitespace
  void addstr(const char *);
  CHTYPE far &operator()(int row,int col);
  CHTYPE operator()(int row,int col) const { return data[d[row].data + col]; }
  CHTYPE inch() const { return (*this)(crow,ccol); }
  void insch(CHTYPE);
  void insch(char c) { insch((CHTYPE)((unsigned char)c | attr)); }
  void move(int row,int col);
  void getyx(int &row,int &col) const { row = crow; col = ccol; }
  void deleteln(int);
  void deleteln() { deleteln(crow); }
  void insertln(int);
  void insertln() { insertln(crow); }
  void delch();
  void clrtoeol(CHTYPE repl = ' ');
  void clrtoeos(CHTYPE repl = ' ');
  void clear(CHTYPE repl = ' ') { move(0,0); clrtoeos(repl); }
  bool scrollok() { return scrollflag; }
  void scrollok(bool f) { scrollflag = f; }
  CursesWin *copy(const Rect &) const;
  void overlay(const CursesWin *);
  void mvprintw(int row,int col,const char *fmt,...);
};
#endif
