// dynamic file types
#pragma interface
#include <String.h>

class DColumn {
public:
  short dlen;	// display length
  const char *name;
  const char *desc;
  DColumn::DColumn(): name(""),desc(""),dlen(0) {}
  virtual DColumn &operator=(const String &) { return *this; }
  virtual operator String() const { return ""; }
  virtual ~DColumn() {}
};

class DCursor {
  static DColumn dummy;
protected:
  DColumn **col;
  short ncol;
  short klen;
public:
  DCursor(): col(0),ncol(0),klen(0) {}
  short kflds() const { return klen; }	// number of key columns
  short ncols() const { return ncol; }	// number of columns
  DColumn &operator[](int i) {
    if (i < 0 || i >= ncol) return dummy;
    return *col[i];
  }
  DColumn &operator[](const String &s) {
    for (int i = 0; i < ncol; ++i)
      if (s == col[i]->name) return *col[i];
    return dummy;
  }
  virtual int next(int = 1) = 0;
  virtual int first(int = 0) = 0;
  virtual int find() = 0;
  virtual int ins() { return -1; }
  virtual int del() { return -1; }
  virtual int update() { return -1; }
  virtual ~DCursor() {}
};

typedef struct obstack Obstack;
class SqlColumn;
class Cursor;

class SqlCursor: public DCursor {
  SqlColumn *cola;
  Cursor *cur;
  Obstack *h;
  //struct priv;
  //priv *p;	// implementation
public:
  SqlCursor(const String &);
  int first(int);
  int next(int = 1);
  int find();
  ~SqlCursor();
};
