#ifndef _Etype_h
#define _Etype_h
#pragma interface
#include <Ftype.h>
#include <Fbin.h>
#include <Keydata.h>

template <int size> class ECHAR: public FBIN<size> {
public:
  ECHAR(const char *s = "") { stebstr(s,(unsigned char *)this->str,size); }
  ECHAR & operator = (string s) {
    stebstr(s.c_str(),(unsigned char *)this->str,size);
    return *this;
  }
  ECHAR & operator = (const ECHAR &a) {
    memcpy(this->str,a.str,size);
    return *this;
  }
  char operator[](int i) const {
    if (i < 0 || i >= size) return ' ';
    return ebcdic((unsigned char)this->str[i]);
  }
  class EcharRef operator[](int i) {
    return EcharRef((i < 0 || i >= size) ? 0 : (unsigned char *)this->str + i);
  }
  int len() const { return blkfntl(this->str + size,0x40,size); }
  operator string() const {
    char buf[size + 1];
    return string(buf,ldebstr(buf,(unsigned char *)this->str,size));
  }
  int compare(const string &s) { return string(*this).compare(s); }
  bool operator ==(const string &s) { return string(*this) == s; }
  bool operator !=(const string &s) { return string(*this) != s; }
  bool operator <(const string &s) { return string(*this) < s; }
};

template <int size>
ostream & operator<<(ostream &os,ECHAR<size> s) { return os << string(s); }
#endif
