#ifndef _Fchar_h
#define _Fchar_h
#pragma interface
#ifdef OLDSTL
#include <ostream.h>
#else
#include <ostream>
#endif
#include <string>
#include <string.h>
#include <stdlib.h>
#include <money.hpp>
#include <fbin.hpp>
#include <ftype.hpp>

template <int size> struct FCHAR: FBIN<size> {
  FCHAR(const char *s = "") { stchar(s,this->str,size); }
  FCHAR(string s) { stchar(s.c_str(),this->str,size); }
  FCHAR & operator = (const char *s) { stchar(s,this->str,size); return *this; }
  FCHAR & operator = (string s) { stchar(s.c_str(),this->str,size); return *this; }
  string operator + (const string &s) const; //{ return string(this->str,len()) + s; }
  string operator + (const char *s) const; //{ return string(*this) + s; }
  char operator[](int i) const { return (i < 0 || i >= size) ? ' ' : this->str[i]; }
#if 1
  int compare(const char *s) const;
  int operator == (const char *s) const { return compare(s) == 0; }
  int operator != (const char *s) const { return compare(s) != 0; }
  int operator == (const string &s) const { return compare(s.c_str()) == 0; }
  int operator != (const string &s) const { return compare(s.c_str()) != 0; }
#endif
  int len() const { return blkfntl(this->str + size,' ',size); }
  operator string() const; // { return string(this->str,len()); }
};

template<int size> ostream& operator<<(ostream& s, FCHAR<size>& x) {
  return s << string(x);
}

template <int size> struct FNUM: FBIN<size> {
  FNUM() { memset(this->str,0,size); }
  FNUM(long m) { Money(m).store(this->str,size); }
  FNUM & operator = (const Money &m) { m.store(this->str,size); return *this; }
  FNUM & operator = (long m) { Money(m).store(this->str,size); return *this; }
  //FNUM & operator = (FBIN<size> &r) { memcpy(this->str,r.str,size); return *this; }
  operator Money() const { return Money(this->str,size); }
  operator long() const { return Money(this->str,size); }
  Money operator +=(const Money &m) {
    Money res(this->str,size); *this = res += m; return res; }
  Money operator -=(const Money &m) {
    Money res(this->str,size); *this = res -= m; return res; }
  Money operator *=(short i) {
    Money res(this->str,size); *this = res.mul(i); return res; }
  Money operator ++() { *this = ++Money(this->str,size); return Money(this->str,size); }
  Money operator --() { *this = ++Money(this->str,size); return Money(this->str,size); }
  string pic(const char *mask) const { return Money(this->str,size).pic(mask); }
  string fmt(short f=0,short w=0) const { return Money(this->str,size).fmt(f,w); }
};

class BitPtr {
  char *ptr, mask;
public:
  BitPtr(char *p, short i) : ptr(p), mask(0x80 >> i) {}
  operator int() const { return *ptr & mask; }
  int operator =(int i) {
    if (i) *ptr |= mask;
    else *ptr &= ~mask;
    return *ptr & mask;
  }
};

template <int size> class FBIT {
  char flg[(size + 7)/8];
public:
  FBIT() { memset(flg,0,(size + 7)/8); }
  BitPtr operator [] (unsigned i) {
    if (i >= size) abort();
    return BitPtr(&flg[i >> 8],i&7);
  }
  int operator [] (unsigned i) const {
    if (i >= size) abort();
    return flg[i >> 8] & (0x80 >> (i&7));
  }
  Keydata operator &() { return Keydata(flg,(size + 7)/8); }
};
#endif
