#ifdef __GNUC__
#pragma interface
#endif
#include "Fcb.h"
#include <isamx.h>

class FileIO: public virtual FcbIO {
  int fd;		/* cisam file descriptor */
  keydesc *k;		/* primary key description */
  const keydesc *vw;	/* current keydesc for viewing */
  const keydesc *curr_vw;	/* current keydesc in use (equal to
					   either k or vw) */
  char *data;		/* Current data buffer			*/
  const char *min, *max;/* current range info or null */
  int len;		/* len of data buffer			*/
  char *tagbuf;		/* tag buffer */
  int tagl;
  char *nullbuf;		/* buffer with current null key */
  int dir;		/* key direction */
public:
  FileIO(int fd, void *buf);
  ~FileIO();
  const keydesc *primary_key() const { return k; }
  Tag first(int);
  Tag next(int = 1);
  Tag locate(Tag tag);
  int taglen() const { return tagl; }
  Tag add(Tag tag,int);
  Tag get(Tag tag);	// get for update (lock)
  Tag update(Tag tag);
  Tag del(Tag tag);
  void clear();
  //int isnull() const;
  //void setnull();
  void blank();
  char *tag();		// copy tag of current record to tagbuf
  void tag(Tag tag);	// copy tag to record
};

#if 0
struct FileVW {
  short fld;
  short revflag;
  keydesc *k;
};

/* fileview.c */
extern void viewkey(FILEIO *,struct keydesc *,int);
extern void viewrange(FILEIO *,const char *,const char *,FCB *);
extern void fileview(FILEIO *, const struct keydesc *, int);
PTR viewio(int func, const PTR tag, PTR iocb);

/* fileloc.c */
extern void filelocate(FILEIO *, FILEVW *);	/* auto fileview by field */
extern void fileloc(FCB *);
#endif
