// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _LQueue_h
#ifdef __GNUG__
#pragma interface
#endif
#define _LQueue_h

#include <Queue.h>

template <class T>
class LQueue: Queue<T> {
  class node {
    node *next;
    T elem;
    node(T&r): elem(r), next(0) {}
  };
  node *first, **last;
  int cnt;
public:
                        LQueue() { first = 0; last = &first; cnt = 0; }
  virtual              ~Queue() { clear(); }

  virtual void          enq(T& item) {
    *last = new node(item);
    last = &(*last)->next;
    ++cnt;
  }

  virtual T           deq() return e; {
    if (first) {
      e = first->elem;
      del_front();
    }
    else
      error("deq from empty Queue");
  }

  virtual T&          front() { return first->elem; }

  virtual void          del_front() {
    if (first) {
      node *p = first->next;
      delete first;
      first = p;
      if (first == 0) last = &first;
      --cnt;
    }
  }

  virtual void          clear() {
    while (first) {
      node *p = first;
      first = p->next;
      delete p;
    }
    cnt = 0; last = &first;
  }

  virtual int           empty() { first == 0; }
  virtual int           full() { return 0; }
  virtual int           length() { return cnt; }

  void                  error(const char*);
  
  virtual int           OK() { return *last == 0; }
};

#endif
