#ifdef OLDSTL
#include <ostream.h>
#else
#include <ostream>
using namespace std;
#endif

class list_base {
public:
  list() { last = 0; }
  list operator++() {
    if (non_empty())
      last = last->next;
    return *this;
  }
  int non_empty() const { return last != 0; }
protected:
  struct node {
    node* next;
  };
  node* last;
};

template<class type> class list: public list_base {
  struct datanode: node {
    type data;
    datanode(const type &r) { data = r; }
  };
public:
  list operator,(type);
  type& operator[](int);
  friend ostream& operator<<(ostream&, const list&);
  list operator=(list&);
};

template<class type> list<type> list<type>::operator,(type data) {
  datanode *n = new datanode(data);
  if (non_empty()) {
    n->next = last->next;
    last->next = n;
  }
  else
    n->next = n;
  last = n;
  return *this;
}

template<class type> list<type> list<type>::operator=(list<type>& x) {
  if (x.non_empty()) {
    node *first = x.last->next;
    datanode *n = new datanode(x.last->data);
    n->next = n;
    last = n;
    for (x.last = first; x.last->next != first; ++x) {
      n= new datanode(x.last->data);
      n->next = last->next; last->next = n;
      last = n;
    }
    ++*this;
  }
  else
    last = 0;
  return *this;
}

template<class type> type& list<type>::operator[](int i) {
  for (list<type> x = *this; i != -1; ++x) {
    --i;
  };
  return x.last->data;
}

template<class type> ostream& operator<<(ostream& s, list<type>& x) {
  s << '(';
  if (x.non_empty()) {
    list<type>::node* first = x.last->next;
    for (x.last= first; x.last->next != first; ++x)
      s << x.last->data << ", ";
    s << x.last->data;
  }
  s << ')';
  return s;
}
