#ifndef _Money_h
#pragma interface
#define _Money_h

#include <string>

using namespace std;

struct MONEY {	// suitable for unions (no ctors or dtors)
  long high;
  unsigned short low;
  MONEY &operator +=(const MONEY &);
  MONEY &operator -=(const MONEY &);
};

class Money {
  long high;
  unsigned short low;
public:
  Money(long = 0);
  Money(double);
  Money(const MONEY &m): high(m.high), low(m.low) {}
  Money(const Money &m): high(m.high), low(m.low) {}
  operator MONEY() const { return *(MONEY *)this; }
  Money(const char *str,const char *mask,int fix = 0);
  char *pic(const char *mask, char *buf) const;
  string pic(const char *mask) const;
  string fmt(short fix = 0,short width = 0) const;
  Money(const char *,int = 6);		// load
  void store(char *,int = 6) const;	// store
  operator double() const;
  operator long() const;
  Money &operator++() { *this += 1L; return *this; }
  Money &operator--() { *this -= 1L; return *this; }
  Money &operator +=(const Money &);
  Money operator +(const Money &a) const { Money t(a); return t += *this; }
  Money &operator -=(const Money &);
  Money operator -(const Money &a) const { Money t(*this); return t -= a; }
  Money &mul(short,short = 0);   // mult by short, add short
  Money &operator *=(double a) { *this = a * double(*this); return *this; }
  Money &operator /=(double a) { *this = a / double(*this); return *this; }
  Money operator *(double a) const { return a * double(*this); }
  Money operator -() const { Money t(*this); return t.mul(-1); }
  int div(short);
  int sgn() const {
    if (high < 0) return -1;
    if (high || low) return 1;
    return 0;
  }
  int operator ==(const Money &a) { return high == a.high && low == a.low; }
  int operator !=(const Money &a) { return high != a.high || low != a.low; }
  int operator <(const Money &a) { return (*this - a).sgn() < 0; }
  int operator <=(const Money &a) { return (*this - a).sgn() <= 0; }
  int operator >(const Money &a) { return (*this - a).sgn() > 0; }
  int operator >=(const Money &a) { return (*this - a).sgn() >= 0; }
  static const Money null;
};

string dec(Money i,int w = 0);
#endif
