extern "C" {
#include <pwd.h>
}
#include <Array.h>

class Plock {
  int fd;
  const char *name;
public:
  Plock(const char * = 0);
  operator int() const { return fd; }
  int operator!() const { return fd >= 0; }
  int lock(const char *);
  int unlock();
  int commit(const char *,const char *backup = 0);
  ~Plock() { unlock(); }
};

class Passwd {
  Plock plock;
  class Obstack *h;
  Array<passwd *> adds, dels;
  char *copy(const char *);
  int isdeleted(const char *name);
  passwd *added(const char *name);
  Passwd(const Passwd &);
  Passwd &operator=(const Passwd &);
public:
  Passwd();
  ~Passwd();
  passwd *operator[](const char *name);
  passwd *operator[](int uid);
  passwd *copy(const passwd *);
  int lock();
  int unlock();
  int commit();
  int insert(const passwd *);
  int update(const passwd *);
  int del(const char *name);
};
