// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _Queue_h
#ifdef __GNUG__
#pragma interface
#endif
#define _Queue_h

#include <builtin.h>

#include "defs.h"

template <class T>
class Queue {
public:
                        Queue() { }
  virtual              ~Queue();

  virtual void          enq(T& item) = 0;
  virtual T           deq() = 0;
  virtual T&          front() = 0;
  virtual void          del_front() = 0;

  virtual void          clear() = 0;
  virtual int           empty() = 0;
  virtual int           full() = 0;
  virtual int           length() = 0;

  void                  error(const char*);
  
  virtual int           OK() = 0;
};

#endif
