/*	Scrollable data tables
	Copyright 1993 Business Management Systems, Inc.
	Author: Stuart D. Gathman
*/
#ifndef __Screen_h
#define __Screen_h
#ifdef __GNUC__
#pragma interface
#endif
#include <string>
#include <Frame.h>
#include <Array.h>
#include <Curses.h>

using namespace std;

class bmsField: public ChildWin, public CursesWin {
  bmsField(const bmsField &);
  bmsField&operator=(const bmsField &);
public:
  bmsField(ChildWin *,short cols,short rows = 1);
  string get() const;
  bmsField &operator=(string r);
  void mark(CHTYPE a);
  void getfocus();
  void key(int);
  void sync() { CursesWin::sync(); }
  void losefocus();
  void put(char);
};

class bmsScreen: virtual public ChildWin {
  bmsScreen(const bmsScreen &);
  bmsScreen &operator=(const bmsScreen &);
  int cur;
public:
  bmsScreen();
  int curfld() const { return cur; }
  void curfld(int c) { cur = c; }
  virtual void show() = 0;	// show record on screen
  virtual void update() { }	// update record from screen
  void getfocus();
  void key(int);
};

#include "scrScreen.h"

// screen with semi manual field positions
class manScreen: public bmsScreen {
  manScreen(const manScreen &);
  manScreen &operator=(const manScreen &);
protected:
  Array<bmsField *> fld;
  Point org;
  void addScrollFld(short len,short plen);
  void addfld(short len) { addScrollFld(len,len); }
  void addfld(short,int,...);
  manScreen(): org(0,0) {}
};
#endif
