#include <sys/types.h>
#include <dirent.h>

class UnixDir {
  DIR *h;
  struct dirent *d;
public:
  UnixDir(const char *s) { h = opendir(s); d = 0; }
  int first() { if (!h) return 0; rewinddir(h); return next(); }
  int next() { return h && (d = readdir(h)); }
  const char *name() const { return d ? d->d_name : 0; }
  long root() const { return d ? d->d_ino : 0; }
  ~UnixDir() { if (h) closedir(h); }
};
