#pragma interface
template <class T>
class auto_ptr {
  T* p;
public:
  auto_ptr(T* pp = 0) : p(pp) { }
  auto_ptr(auto_ptr<T>& x) : p(x.p) { x.p = 0; }
  void reset(T *pp = 0) { if (p != pp) delete p; p = pp; }
  ~auto_ptr() { delete p; }
  T* operator->() { return p; }
  T &operator*() { return *p; }
  T* get() const { return p; }
  T* release() { T* pp = p; p = 0; return pp; }
  auto_ptr<T>&operator=(T* pp) { reset(pp); return *this; }
  auto_ptr<T>&operator=(auto_ptr<T>& x) { reset(x.release()); return *this; }
};

template <class T>
class auto_array {
  T* p;
public:
  auto_array(T* pp = 0) : p(pp) {}
  auto_array(auto_array<T>& x) : p(x.p) { x.p = 0; }
  void reset(T *pp) { if (p != pp) delete [] p; p = pp; }
  ~auto_array() { delete [] p; }
  T& operator [](int i) { return p[i]; }
  T* get() const { return p; }
  T* release() { T* pp = p; p = 0; return pp; }
  auto_array<T>&operator=(T* pp) { reset(pp); return *this; }
  auto_array<T>&operator=(auto_array<T>& x) {
    reset(x.release()); return *this; }
};
