#pragma interface
#include <cipher.h>

class Blowfish: public BlockCipher {
  typedef unsigned long ulong;
  enum { N = 18 + 4 * 256 };
  ulong P[N];
  const ulong *S(int i) const { return P + 18 + (i << 8); }
  ulong S1(ulong x) const { return S(0)[x>>24]; }
  ulong S2(ulong x) const { return S(1)[(x>>16)&255]; }
  ulong S3(ulong x) const { return S(2)[(x>>8)&255]; }
  ulong S4(ulong x) const { return S(3)[x&255]; }
  ulong F(ulong x) const { return ((S1(x) + S2(x)) ^ S3(x)) + S4(x); }
  static const ulong PI[N];	// binary fraction PI - 3
public:
  Blowfish();
  void setkey(const char *key,int keysize = -1);
  bool isweak() const;	// check for weak key
  void encrypt(const char *,char *);
  void decrypt(const char *,char *);
};
