#pragma interface

class BlockCipher {
protected:
  int blksize;
  static void ldkey(void *dst,int dlen,const char *src,int slen);
public:
  int blockSize() const { return blksize; }	// bytes in cipher block
  virtual void setkey(const char *,int = -1) = 0;
  virtual bool isweak() const { return false; }	// check for weak key
  virtual void encrypt(const char *,char *) = 0;
  virtual void decrypt(const char *,char *) = 0;
  void encrypt(char *x) { encrypt(x,x); }	// encrypt in place
  void decrypt(char *x) { decrypt(x,x); }	// decrypt in place
  virtual ~BlockCipher() { }
};

