#pragma interface
#include <Browse.h>
#include <Select.h>
#include "textfile.h"

struct PipeBrowser: TextBrowser, private SelectPoll {
  // label the window and display the data from a file descriptor
  PipeBrowser(int fd,const char *label ="(stdin)");
  // just label the window.  You still have to use open(int).
  PipeBrowser(const char *label);
  ~PipeBrowser();
  void key(int);
  void handler();
  void load(const string &) { }
  void saveAs(const string &) { }
  void open(int);
private:
  PipeBrowser(const PipeBrowser &);
  PipeBrowser&operator=(const PipeBrowser &);
  long oldsize;
  char tail;
protected:
  BufFile pipe;
};

struct CmdBrowser: PipeBrowser {
  CmdBrowser(string);
  ~CmdBrowser();
private:
  CmdBrowser(const CmdBrowser &);
  CmdBrowser&operator=(const CmdBrowser &);
  FILE *p;
};
