#pragma interface

/* T queue */
template <class T>
class Fifo {
#ifdef __MSDOS__
  void far *base;	/* allocated pointer */
  T _seg *buf;
#else
  T *buf;
#endif
  unsigned bptr, eptr;
  Fifo(const Fifo &);
  Fifo&operator=(const Fifo &);
public:
  unsigned size;		/* total size of queue */
  unsigned count;		/* number of Ts in queue */
  Fifo(unsigned s);
  ~Fifo() {
#ifdef __MSDOS__
    delete [] base;
#else
    delete [] buf;
#endif
  }

  void put(T c) {	/* add to end of queue */
    if (eptr >= size) eptr = 0;
    buf[eptr++] = c;
    ++count;
  }

  void puti(T c) {	/* add to front of queue */
    if (!bptr) bptr = size;
    buf[--bptr] = c;
    if (count < size) ++count;
    else {
      if (!eptr) eptr = size;
      --eptr;
    }
  }

  T get() {		/* return front of queue */
    if (bptr >= size) bptr = 0;
    --count;
    return buf[bptr++];
  }

  void clear() { bptr = eptr = count = 0; }

  int getdata(const T * &p);
  int putdata(T * &p, int desired);
};
