#pragma interface
#include <textlist.h>

class BufFile: public TextArray {
  Array<long> pos;
  long filesize;
  char eof;
  BufFile(const BufFile &);
  BufFile&operator=(const BufFile &);
protected:
  class bufio *io;
public:
  BufFile(const char *);
  BufFile();
  void open(int);
  ~BufFile();
  /** Return null terminated text of line. */
  const char *operator[](int);
  /** Return file offset of line number. */
  long offsetOf(int);
  /** Return number of lines in file. */
  int size();
  int getfd() const;
  int ateof() const { return eof; }
  /** Enable reading more lines at eof.  Useful when file is a pipe. */
  void reseteof() { eof = 0; }
  void rewind();
};
